package path;

public class Node implements Comparable<Node> {
	public int x, y;
	public double distanceFromStart;
	public double hueristicDistanceToGoal;
	private boolean isObstacle;
	public Node parent;
	
	public Node(int x, int y) {
		this.x = x;
		this.y = y;
	}
	
	@Override
	public int compareTo(Node other) {
		double totalDistanceFromGoal = this.distanceFromStart + this.hueristicDistanceToGoal;
		double otherDistanceFromGoal = other.distanceFromStart + other.hueristicDistanceToGoal;
		if (totalDistanceFromGoal < otherDistanceFromGoal)
			return -1;
		if (totalDistanceFromGoal > otherDistanceFromGoal)
			return 1;
		return 0;
	}
	
	public boolean equals(Node other) {
		return this.x == other.x && this.y == other.y;
	}
	
	public void setNodeAsObstacle() {
		isObstacle = true;
	}
	
	public void removeNodeAsObstacle() {
		isObstacle = false;
	}
	
	public boolean isObstacle() {
		return isObstacle;
	}
}
