package test;

import java.util.ArrayList;
import path.Area;
import path.Game;
import path.Node;

public class Test {
	public Area map;
	public Node start;
	public Node goal;
	public Input input;
	
	private ArrayList<Node> path;
	
	public Test() {
		start = new Node(0, 0);
		goal = new Node(1, 1);
		
		map = new Area(Game.SCALED_WIDTH, Game.SCALED_HEIGHT);
		System.out.println("Setting up the path.");
		path = map.createPath(start, goal);
		System.out.println("Path complete.");
		input = new Input();
	}
	
	public void tick() {
		if (input.mouseClicked) {
			System.out.println("Mouse has clicked...");
			input.mouseClicked = false;
			
			copy(start, goal);
			start = new Node(input.mouseX / Game.SCALE, input.mouseY / Game.SCALE);
			System.out.println("Map is now generating path...");
			path.clear();
			path = map.createPath(start, goal);
		}
	}
	
	public void render(int[] data) {
		clear(data);
		data[start.x + start.y * Game.SCALED_WIDTH] = 0xFFAAFFAA;
		
		if (path != null) {
			if (!path.isEmpty()) {
				for (Node node : path) {
					data[node.x + node.y * Game.SCALED_WIDTH] = 0xFFC0C0C0;
				}
			}
		}
		
		data[goal.x + goal.y * Game.SCALED_WIDTH] = 0xFFFFAAFF;
		showObstacle(data);
	}
	
	private void showObstacle(int[] data) {
		for (ArrayList<Node> iterator : map.getNodeMap()) {
			for (Node node : iterator) {
				if (node.isObstacle())
					data[node.x + node.y * Game.SCALED_WIDTH] = 0xFFAABCD0;
			}
		}
	}
	
	private void clear(int[] data) {
		for (int i = 0; i < data.length; i++)
			data[i] = 0;
	}
	
	private void copy(Node src, Node dst) {
		dst.x = src.x;
		dst.y = src.y;
		dst.distanceFromStart = 0;
		dst.hueristicDistanceToGoal = 0;
		dst.parent = null;
	}
}
